//   .                   
//	startcd.narod.ru 
//	startcd@yandex.ru
//  ,  ,     .
//	mega8
//	v0.41 8    
//	v0.4  U   .
//  v0.32     
//	v0.31    37 .
// 	v0.3       ~32   2 
//	v0.1 ni-cd   "  "
//	v0.2 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h> /*F_CPU = 8000000; _delay_ms max = 262.14 ms / F_CPU in MHz = 32,7675mS; _delay_us max = 768 us / F_CPU in MHz.= 96uS*/
#include "nimh8.h"

//#define versia_alg_2

ISR(TIMER0_OVF_vect){//0.00204//0,004096
unsigned char i;
TCNT0=131;// 1/clock * 64 * 250 = 0.001
	//for(i=0; i<5; i++){
	for(i=4; i!=0xFF; i--){
		time[i]--;
		if ( time[i]==0 ){
			flag_isr|=BIT(i);
			if ( i == cl_isr ) time[cl_isr]=100;
			}
		}
}

ISR(USART_RXC_vect){

	if ( !(uart_flag & fl_rx_buff) ){
		time[timeout]=20;
		uart_buff[uart_nb]=UDR;//
		if ( ++uart_nb >= 17 ){			
			if ((uart_buff[0]==0x17)&&(uart_buff[16]==0x71))
				uart_flag|=fl_rx_buff;
			uart_nb=0;
			//UCSRB&=~BIT(RXCIE);
			}

		}
}

void acd_init(void)
{
	#define ADMUXSETTING	( BIT(REFS1)|BIT(REFS0) )
	ADMUX=ADMUXSETTING;
	//ADMUX=BIT(REFS1)|BIT(REFS0);//Internal 2.56V Voltage Reference with external capacitor at AREF pin
//!!!	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS1)|BIT(ADPS0);
	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS1);// clock/64 time= 8uSek
}

void timer1_init(void)
{
	OCR1A=0x00;
	OCR1B=0x00;
	TCCR1A=BIT(WGM10);//BIT(WGM10);//Clear OC1A/OC1B on compare match//BIT(COM1A1)|BIT(COM1B1)|
	TCCR1B= BIT(WGM12)|BIT(CS10);//mode 5
	//TIMSK|=BIT(TOIE1);
}

void timer0_init(void){
	TCCR0|=BIT(CS00)|BIT(CS01);//clock/64 0.00204
	TIMSK|=BIT(TOIE0);
}

void port_init(void){
	DDRDECH|=decharge_A|decharge_B;
	PORTPWM&=~OC1A;//PORTB&=~BIT(PB1);
	PORTPWM&=~OC1B;//PORTB&=~BIT(PB2);
	DDRPWM|=OC1A;
	DDRPWM|=OC1B;
	//DDRD=led_common;
	
	DDR_POWER_OFF|=OUT_POWER_OFF;
	PORT_POWER_OFF|=OUT_POWER_OFF;
	PORT_SEL_BOD|=IN_SEL_BOD; //  USART_Init,  ,   9600  38400 
}

void USART_Init( void )
{
/* Set baud rate */
	//UBRRH = (unsigned char)(baud>>8);
	if ( PIN_SEL_BOD & IN_SEL_BOD ) //  ,   9600  38400 
		UBRRL = 12; else UBRRL = 51;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);///* Enable receiver and transmitter */
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);/* Set frame format: 8data, 2stop bit */
}

void avr_init(void)
{
    acd_init();
	timer1_init();
	timer0_init();
	port_init();
	USART_Init();
		sei();
}
//-------------------------------------------------------------------------------------
void power_off(void)
{	//      
	if (power_off_ON) //        
		if 
		( //         (  == 0)
		( (flag_err_A & _akk_end_charge) || (state_A==0) )
		&&
		( (flag_err_B & _akk_end_charge) || (state_B==0) )
		)
		PORT_POWER_OFF&=~OUT_POWER_OFF;
}

// ***********************************************************
//   
unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));	/*     */
	EEAR = uiAddress;			/*    */
	EECR |= (1<<EERE);			/*       EERE */
	return EEDR;				/*      */
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));/*     */
		cli();
		EEAR = uiAddress;/*     */
		EEDR = ucData;
		EECR |= (1<<EEMWE);/*  . 1   EEMWE */
		EECR |= (1<<EEWE);/*       EEWE */
		sei();
		}
}
//*********************************************

//--------------------------------------------
void dprg_EEPROM_write(void){
unsigned char  i, *uk;
	dprg.crc=0;
	uk=(unsigned char *)&dprg;
	for( i=0 ; i<sizeof(dprg) ; i++ ){
		EEPROM_write(i+EEPROM_dprg, *(uk+i));
		if (i<sizeof(dprg)-2)
		 dprg.crc+=*(uk+i);
		}
}
//--------------------------------------------
void dprg_EEPROM_read(void){
unsigned char  i, *uk;
unsigned int crc_read=0;
	uk=(unsigned char *)&dprg;
	for( i=0; i<sizeof(dprg) ; i++){
		*(uk+i)=EEPROM_read(i+EEPROM_dprg);
		if (i<sizeof(dprg)-2)
			crc_read+=*(uk+i);
		}
	if (dprg.crc!=crc_read) data_error=1;
}
//--------------------------------------------
void data_init(void){
unsigned char *t;
unsigned int *a;
	if ( swt & sw_nimh_nicd )
		{
		a=&dprg.tok_cd_fast;
		t=&dprg.mincd;
		trickle_i=dprg.tok_cd_trickle;
		}
		else
		{
		a=&dprg.tok_mh_fast;
		t=&dprg.minmh;
		trickle_i=dprg.tok_mh_trickle;
		}
	FAST_I=*a;
	alarm_time[0]=*t;
	alarm_time[1]=*(t+1);
}
//-------------------------------------------------------------------------------------

void USART_Transmit( unsigned char data )
{
	UCSRB|=BIT(TXEN);
/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) )
	;
/* Put data into buffer, sends the data */
	UDR = data;
}

//*********************************************
void verify_time(unsigned int *time, unsigned char *flag, unsigned char state){
	if (state>20)
		if ( --(*time)==0 ) *flag|=_akk_error_time;
}

void clock_AB(void){
static uint8_t tim_7sek=0;
	if ( flag_isr & BIT(cl_isr) ){
		flag_isr &=~BIT(cl_isr);

		if ( ++clock[0] == 10 ){ // 1 sek
			clock[0]=0;
			if ( ++clock[1] == 60 ){ // 1 min
				clock[1]=0;
				minute++;
				verify_time(&clock_A,&flag_err_A, state_A);
				verify_time(&clock_B,&flag_err_B, state_B);
				}
			if (++tim_7sek==7) {//7 sek
				tim_7sek=0;
				time_T++;
				}
			power_off();
			}
		flag_A|=_t_r_verify;
		flag_B|=_t_r_verify;
		}
}

void set_alarm_time(uint16_t *clock, unsigned char hours, unsigned char minut){
	*clock=hours*60+minut;
}

//**************************************

void delay01_next_state_A( unsigned char t, unsigned char next_state){
static uint8_t j, fl=0;

	if ( fl==0 ) {
		fl= 1;
		j=0;
		time[time_A]=100;//0.1sek- 0.001*100	
		}
	
	if (time[time_A]<=0){
		time[time_A]=100;
		if (++j>=t){
			fl = 0;
			state_A=next_state;
			}
		}
}

void delay01_next_state_B( unsigned char t, unsigned char next_state){
static uint8_t j, fl=0;

	if ( fl==0 ) {
		fl = 1;
		j=0;
		time[time_B]=100;//0.01sek
		}

	if (time[time_B]<=0){
		time[time_B]=100;
		if (++j>=t){
			fl = 0;
			state_B=next_state;
			}
		}
}


//****************************
void pwm_A_on(void){
	TCCR1A|=BIT(COM1A1);
	OCR1A=0x01;					//debug
}
void pwm_A_off(void){
	TCCR1A&=~BIT(COM1A1);
	PORTPWM&=~OC1A;
	OCR1A=0x00;
	flag_A &=~ _tok_on;
}
//----------------------------
void pwm_B_on(void){
	TCCR1A|=BIT(COM1B1);
	OCR1B=0x01;					//debug
}
void pwm_B_off(void){
	TCCR1A&=~BIT(COM1B1);
	PORTPWM&=~OC1B;
	OCR1B=0x00;
	flag_B &=~ _tok_on;
}
//******************************************************************************
void Stable_ADC(void)                     // loop until you have a stable value
{
  int V[4];
  int Vmax, Vmin;
	
    //Loop until the ADC value is stable. (Vmax <= (Vmin+1))
    for (Vmax=10,Vmin= 0;Vmax > (Vmin+1);)
    {
		//delay(255);
		uint8_t i=0xFF;
		while(i--);
		
		V[3] = V[2];//  
        V[2] = V[1];
        V[1] = V[0];//   v[0]
        ADCSRA |= BIT(ADSC);                      // Start a new A/D conversion
        while ( !(ADCSRA & BIT(ADIF)) )        // wait until ADC is ready
            ;
        V[0] = ADC;
        Vmin = V[0];                          // Vmin is the lower VOLTAGE
        Vmax = V[0];                          // Vmax is the higher VOLTAGE
        /*Save the max and min voltage*/
        for (uint8_t i=0;i<=3;i++)
        {
            if (V[i] > Vmax)//   4   Vmax
                Vmax=V[i];
            if (V[i] < Vmin)//  Vmin  4   Vmin
              Vmin=V[i];
        }
    } //     : Vmax <= (Vmin+1)
}

unsigned int adc_rezult(unsigned char kanal){
	unsigned int rez=0;
	
	ADMUX=ADMUXSETTING|kanal;

	for(uint8_t i=8 ; i ; i--){
		ADCSRA|=_BV(ADSC);
		while ( !(ADCSRA & BIT(ADIF)) );//while( ADCSRA & BIT(ADSC) );
		//if (i!=9) //    //  ,    .
		rez+=ADC;
		}
	return rez/8;
}
//******************************************************************************

//-------------------Temperatura--------------------------------------------

//-----------------  A------------------------------------
signed int receive_t_a(void){
    static int16_t Sum = 0;
    int16_t tmp = (Sum + 2) >> 2;//    4 
    Sum += adc_rezult(Tempir_A) - tmp;
	return ( ( tmp-dprg.u_tempirA)*10/dprg.tstep )+dprg.tofset*10;
}
void verify_t_a(void){

int16_t t=receive_t_a();
	if (  t >= dprg.t_alarm*10 )  
			flag_err_A|=_akk_err_tempir;
			
	if (last_time_T_A	!=	time_T){//7sek
		last_time_T_A	=	time_T;
		
		temperatura[_A_][head_T_A]=t;// ,      
		head_T_A=(head_T_A+1) & mask_temper_buff;//  ,    
		
		if ( t-temperatura[_A_][head_T_A] >= dprg.t_increment ) 
				flag_err_A|=_akk_err_tempir;
		}
}

//-----------------  B------------------------------------
signed int receive_t_b(void){
    static int16_t Sum = 0;
    int16_t tmp = (Sum + 2) >> 2;
    Sum += adc_rezult(Tempir_B) - tmp;
	return ( ( tmp-dprg.u_tempirB)*10/dprg.tstep )+dprg.tofset*10;
}
void verify_t_b(void){

int16_t t=receive_t_b();
	if (  t >= dprg.t_alarm*10 )  
			flag_err_B|=_akk_err_tempir;
			
	if (last_time_T_B	!=	time_T){
		last_time_T_B	=	time_T;
		
		temperatura[_B_][head_T_B]=t;// ,      
		head_T_B=(head_T_B+1) & mask_temper_buff;//  ,    
		
		if ( t-temperatura[_B_][head_T_B] >= dprg.t_increment ) 
				flag_err_B|=_akk_err_tempir;
		}
}

//-----------------Init_masiw for usrednenie------------------------------
void tempir_init_massif_a( void ){
	for(uint8_t i=50; i; i--) receive_t_a();
	for(uint8_t i=0; i<mask_temper_buff+1; i++) temperatura[_A_][i]=receive_t_a();
}
void tempir_init_massif_b( void ){
	for(uint8_t i=50; i; i--) receive_t_b();
	for(uint8_t i=0; i<mask_temper_buff+1; i++) temperatura[_B_][i]=receive_t_b();
}
//-----------------End-Temperatura----------------------------------------

//------------------Send_UART_STR-----------------------------------------
void send_str(unsigned char kanal){
unsigned int *u;
signed int temperatura;	
	
	if ( swt & sw_uart ) {
		if ( kanal==_A_ ) {
			u=&Uakk_A[0];
			temperatura=receive_t_a();
			}
			else {
			u=&Uakk_B[0]; 
			temperatura=receive_t_b();
			}
		
		USART_Transmit(kanal+1);
		USART_Transmit( (*u)>>8 );
		USART_Transmit(  *u );
		USART_Transmit(temperatura>>8);
		USART_Transmit(temperatura);
		}
}
void send_end_err_str(unsigned char kanal){
unsigned char *u;	
	if ( swt & sw_uart ) {
		if ( kanal==0 ) u=&flag_err_A; else u=&flag_err_B; 
		USART_Transmit(kanal+0x03);	//  
		USART_Transmit(*u);
		USART_Transmit(0);
		USART_Transmit(0);
		USART_Transmit(0);
		}
}
//----------------END--Send_UART_STR--------------------------------------

//---------------------Kanal_A--------------------------------------------------
void verify_error_A(void){
	if ( flag_err_A & uslovie_end_charge ){
		pwm_A_off();
		PORTDECH&=~decharge_A;
		PORTLED&=~led_1_A;
		PORTLED|= led_2_A;
		state_A=1;
		if ( flag_err_A & _akk_end_charge )	power_off_ON=1; else send_str(_A_);
		}
}
//************************************
void verify_tok_A(void)
{
unsigned int Iakk_A, ocr;

	//if ( !(en_I_A_B & BIT(0)) )
	if ( flag_A & _tok_on ){

		Iakk_A=adc_rezult(Current_A);
		ocr=OCR1A;
		if (Iakk_A<tok_A){
			if ( ++ocr > 200 ) flag_err_A |= _akk_err_ocr;
			}
		else
		if (Iakk_A>tok_A){
			if (ocr>1)
				ocr--;
			}
		OCR1A=ocr;
		/*	
			if ( ++data_error==100) data_error=0;
			ocr[data_error]=OCR1A;
			adc[data_error]=(unsigned char)Iakk_A;
			Iakk_A=0;
		*/	
		}
}
//************************************
void verify_r_a(void){
unsigned int Uakk, Ur;
	Ur=adc_rezult(Current_A);
	Uakk=adc_rezult(Volt_A);
	if ( Uakk-Ur>740 ) flag_err_A|=_akk_error_R_hi;// U>1.85V
}
//************************************
unsigned int stop_pwm_U_rec_A(void){
unsigned int U;
	pwm_A_off();
	ADMUX=ADMUXSETTING|Volt_A;
	Stable_ADC();//
	U=adc_rezult(Volt_A);
	if ( U<160 )
		flag_err_A|=_akk_error_U_low;//  0,4v
	else	
	if (U>680)
		flag_err_A|=_akk_error_U_hi;//>1.81V(680)debug
	return U;
}
//************************************
void start_pwm_A( unsigned int tok_, unsigned char state_ )
{
//    ,
	if ( !(flag_A & _start_pwm) ){
		flag_A |= _start_pwm;
		flag_A&=~_tok_on;
		tok_A=tok_;
		time[time_A]=1;
		pwm_A_on();
		}
	
	if ( flag_isr & BIT(time_A) ){
		flag_isr &=~BIT(time_A);
		time[time_A]=2;

		if (  adc_rezult(Current_A) >= tok_A){
			flag_A|= _tok_on;
			flag_A&=~_start_pwm;
			state_A=state_;
			return;
			}
		
		uint16_t
		ocr=OCR1A;
		if ( ++ocr > 200 ) flag_err_A |= _akk_err_ocr;
		OCR1A=ocr;
		}
	
}
//---------------------End--Kanal_A---------------------------------------------

//---------------------Kanal_B--------------------------------------------------
void verify_error_B(void){
	if ( flag_err_B & uslovie_end_charge ){//
		pwm_B_off();
		PORTDECH&=~decharge_B;
		PORTLED&=~led_1_B;
		PORTLED_2B|= led_2_B;
		state_B=1;
		if ( flag_err_B & _akk_end_charge ) power_off_ON=1; else send_str(_B_);
		}
}
//************************************
void verify_tok_B(void)
{
unsigned int Iakk_B, ocr;

	//if ( en_I_A_B & BIT(0) )
	if ( flag_B & _tok_on ){

		Iakk_B=adc_rezult(Current_B);
		ocr=OCR1B;
		if (Iakk_B<tok_B){
			if ( ++ocr > 200 ) flag_err_B |= _akk_err_ocr;
			}
		else
		if (Iakk_B>tok_B){
			if (ocr>1)
				ocr--;
			}
		OCR1B=ocr;
		}
}
//************************************
void verify_r_b(void){
unsigned int Uakk, Ur;
	Ur=adc_rezult(Current_B);
	Uakk=adc_rezult(Volt_B);
	if ( Uakk-Ur>740 ) flag_err_B|=_akk_error_R_hi;// U>1.85V
}
//************************************
unsigned int stop_pwm_U_rec_B(void){
unsigned int U;
	pwm_B_off();
	ADMUX=ADMUXSETTING|Volt_B;
	Stable_ADC();//
	U=adc_rezult(Volt_B);
	if ( U<160 )
		flag_err_B|=_akk_error_U_low;//  0,4v
	else	
	if (U>680)
		flag_err_B|=_akk_error_U_hi;//>1.81V(680)debug
	return U;
}
//************************************
void start_pwm_B( unsigned int tok_, unsigned char state_ )
{
//    ,
	if ( !(flag_B & _start_pwm) ){
		flag_B |= _start_pwm;
		flag_B&=~_tok_on;
		tok_B=tok_;
		time[time_B]=1;
		pwm_B_on();
		}
	
	if ( flag_isr & BIT(time_B) ){
		flag_isr &=~BIT(time_B);
		time[time_B]=2;

		if (  adc_rezult(Current_B) >= tok_B){
			flag_B|= _tok_on;
			flag_B&=~_start_pwm;
			state_B=state_;
			return;
			}
		
		uint16_t	
		ocr=OCR1B;
		if ( ++ocr > 200 ) flag_err_B |= _akk_err_ocr;
		OCR1B=ocr;
		}
}
//---------------------End--Kanal_B---------------------------------------------

//------------------Scan--Button--------------------
unsigned char sw_btn_led(unsigned char com){
unsigned char tmp,tmp2,rezult;

	DDRDLED=0;//DDRDLED&=~(sw_common|bt_common|led_common); //   Z 
	DDRB&=~BIT(0);//~led_2_B
	tmp=PORTLED&pin_led;//  led
	tmp2=PORTB;//&BIT(0);//  led
	PORTLED|=pin_led;//pullup
	PORTB|=BIT(0);//pullup
	DDRDLED=com;//  PORT=0 DDR=1   0
	_delay_us(5);
	rezult=PINBTN&pin_led; //0b1110_0000
	if ( PINB & BIT(0) ) rezult|=BIT(0);
	PORTLED&=tmp|(~pin_led);//  led
	if ( ( tmp2&BIT(0) )==0 ) PORTB&=~BIT(0);//  led
	DDRDLED=0;// 
	DDRDLED=led_common|pin_led;
	DDRB|=BIT(0);//led_2_B
	return ~rezult;
}
//------------------Begin--Button--------------------
void state_A_0(void){
	if ( btn & btn_decharge_A ){
		state_A=0;
		PORTLED&=~led_1_A;
		PORTLED&=~led_2_A;
		}
}

void start_charge_A(void){

	if ( btn & btn_start_A ){
		if ( btn & btn_decharge_A ) state_A=140;
		else state_A=20;
		}
}
//----------------------------------------------
void state_B_0(void){
	if ( btn & btn_decharge_B ){
		state_B=0;
		PORTLED&=~led_1_B;
		PORTLED_2B&=~led_2_B;
		}
}

void start_charge_B(void){

	if ( btn & btn_start_B ){
		if ( btn & btn_decharge_B ) state_B=140;
		else state_B=20;
		}
}
//-----------------End-----Button--------------------

//-----------------Begin---seting--------------------
void cls_uart_buff(void){
unsigned char i;
	for(i=0; i< sizeof(uart_buff) ; i++)
	uart_buff[i]=0;
}

void seting(void){
unsigned char  *uk, i;
	UCSRB=BIT(RXCIE)|BIT(RXEN);
	cli();
	if (time[timeout]>20)
	uart_nb=0;
	sei();	
	
	if (uart_flag & fl_rx_buff) {
	/*	for(i=0; i< sizeof(uart_buff) ; i++)
		USART_Transmit(uart_buff[i]);
	*/		
		switch (uart_buff[1])
			{
			case (0x01):// reset
				(*funcptr)();
				break;
			case (0x10)://   EEPROM
				uk=(unsigned char*)&dprg;
				for( i=0; i < dprg_end_wr ; i++)
					*(uk+i)=uart_buff[i+2];
				dprg_EEPROM_write();
				data_error=0;
				PORTLED&=~pin_led;//led on
				PORTLED_2B&=~led_2_B;
				//break;
			case (0x20)://  
				uk=(unsigned char *)&dprg;
				for (i=0; i<sizeof(dprg) ; i++)//
					USART_Transmit( *(uk+i) );//
				break;
			case (0x30)://    
				if (uart_buff[2]==0x30){
					dprg.tofset=uart_buff[_tofset_];
					dprg.tstep=uart_buff[_tstep_];
					uint16_t adc=0;
					for( i=8; i  ; i-- ) adc+=adc_rezult(Tempir_A);
					dprg.u_tempirA=adc/8;    //adc_rezult(Tempir_A);
					adc=0;
					for( i=8; i  ; i-- ) adc+=adc_rezult(Tempir_B);
					dprg.u_tempirB=adc/8;    //adc_rezult(Tempir_B);
					dprg_EEPROM_write();
					//uart_flag&=~fl_rx_buff;
					}
			case (0x31)://  	
				USART_Transmit(0x30);
				int16_t t;
				t=receive_t_a();
				USART_Transmit( t>>8 );
				USART_Transmit( t );
				t=receive_t_b();
				USART_Transmit( t>>8 );
				USART_Transmit( t );
				break;
			}
			cls_uart_buff();
			uart_flag&=~fl_rx_buff;
			//UCSRB|=BIT(RXCIE);
		}
}
//--------------end---seting------------------------


int main(void)
{

signed char tmp_a=0, usr_a=0, large_a=0, maxlarge_a=0, countpolk_a=0, u_stil_a=0, no_polk_a=0;
signed char tmp_b=0, usr_b=0, large_b=0, maxlarge_b=0, countpolk_b=0, u_stil_b=0, no_polk_b=0;

	//asm("nop");

//OSCCAL=0xBB;
OSCCAL=pgm_read_byte_near(&osccal);// adress = 0x26

    avr_init();
	dprg_EEPROM_read();

	sw_btn_led(bt_common);//-----------------
	PORTLED|=pin_led;//led on
	PORTLED_2B|=led_2_B;//-------------------

	//-------delay 1sek-----------
	state_A=1;
	do
	{
	delay01_next_state_A(10,0);
	clock_AB();
	//seting();
	}
	while(state_A);
	//---------delay 1sek-----------

	if (!data_error){
		PORTLED&=~pin_led;//led on
		PORTLED_2B&=~led_2_B;
		}
	
	set_alarm_time(&clock_A,10,00);
	set_alarm_time(&clock_B,10,00);

while(1)
{

//***************************************************************************
	clock_AB();
	
	if ( flag_isr & BIT(tim_sw_btn) )
		{
		flag_isr &= ~BIT(tim_sw_btn);
		swt=sw_btn_led(sw_common);
		btn=sw_btn_led(bt_common);
		}
//***************************************************************************

	switch (state_A)
	{
		case (0):
			//  
			if (  swt & sw_uart )
			seting();
			else
			UCSRB=0;
			
			if (!data_error)
				{
				state_A_0();
				start_charge_A();
				}
			
			break;
		//---------------------error------------------------
		case (1):
			/*if ( swt & sw_uart ) {
				USART_Transmit(0x03);	//  
				USART_Transmit(flag_err_A);
				USART_Transmit(0);
				USART_Transmit(0);
				USART_Transmit(0);
				}*/
			send_end_err_str(_A_);
			if ( flag_err_A & _akk_end_charge )
						state_A=0;
				else  	state_A=2;	
			tmp_a=1;
			large_a=flag_err_A;
			flag_err_A=0;
			break;
		case (2):
			PORTLED|=led_2_A;
			delay01_next_state_A(4,3);
			break;
		case (3):
			PORTLED&=~led_2_A;
			//start_charge_A();
			state_A_0();
			delay01_next_state_A(3,4);
			break;
		case (4):
			if	( tmp_a&large_a )
				state_A=5;
				else
				state_A=2;
			tmp_a<<=1;
			break;
		case (5):
			tmp_a=1;
			//start_charge_A();
			state_A_0();
			delay01_next_state_A(12,2);
			break;
		//------------------end--error---------------------
		case (20):
			data_init();
			UCSRB&=~(BIT(RXCIE)|BIT(RXEN));//  
			PORTDECH&=~decharge_A;
			PORTLED|=led_1_A;
			PORTLED&=~led_2_A;
			
			tmp_a=usr_a=0, large_a=0, maxlarge_a=0, countpolk_a=0, u_stil_a=0, no_polk_a=0;
			flag_err_A=0;
			power_off_ON=0;
			flag_A=0;
			if ( swt & sw_decharge_imp ) flag_A|=_alg_on;
			
			for(tmp_a=sizeof(Uakk_A)/2-1;tmp_a!=-1;tmp_a--) Uakk_A[tmp_a]=0;
			
			tempir_init_massif_a();//     
			
			Uakk_A[0]=stop_pwm_U_rec_A();//   .  U>0.8?
			
			set_alarm_time(&clock_A,00,30);
			verify_t_a();//  

			send_str(_A_);
			state_A=25;
			break;
		
		case (25)://************************[    ]*************************
			start_pwm_A( 10, 27 );//  ~ 50ma
			break;
		case (27):
			delay01_next_state_A(50,28);
			if (flag_A & _t_r_verify){
				flag_A &= ~_t_r_verify;
				verify_r_a();//   U > 1,8  .    R - 
				verify_t_a();//  
				}
			break;
		case (28):
			if ( stop_pwm_U_rec_A()>400 ) state_A=50; //     
			else	state_A=25;//     U>1
			break;//**********************[ end    ]**********************	
		
		//----------------------------------[    ]-------------------------------	
		case (50)://***********[    ]**************
			set_alarm_time(&clock_A,alarm_time[1],alarm_time[0]);// 
			state_A=51;
			break;
		case (51):
			state_A=52;
			start_pwm_A( FAST_I, 87 );
			break;
		case (52):
			delay01_next_state_A(10,51);
			if (flag_A & _t_r_verify){
				flag_A &= ~_t_r_verify;
				verify_r_a();//   U > 1,8  .    R - 
				verify_t_a();//  
				}
			break;//***********[    ]**************
		
		
		case (70)://**************[ FAST CHARGE ]*********************
		//  ,  U   dV0,  ,    40
			if ( swt & sw_decharge_imp )
				state_A=84;
				else{
				state_A=80;
				pwm_A_off();//   
				_delay_ms(30);
				}
				
			Uakk_A[8]+=stop_pwm_U_rec_A();
			if ( ++usr_a >= 8 )
			{
				usr_a=0;
				Uakk_A[8]=Uakk_A[8]/8;//   8 
				
				for ( tmp_a=7 ; tmp_a>0 ; tmp_a-- ){//    
					Uakk_A[tmp_a]=Uakk_A[tmp_a-1];
					}
				Uakk_A[0]=Uakk_A[8];
				Uakk_A[8]=0;
				//    
			//-----------------------------------------------------------------------------------------------
			//----------------- 8  ----------------------------------------------------
			if (  !(flag_A & _alg_on)  )
				if ( ++ large_a == 8 ) {flag_A|=_alg_on; large_a=0;}
			//-----------------------------------------------------------------------------------------------
			
			int8_t prir;
			for ( prir=tmp_a=0; tmp_a<7 ; tmp_a++ )//  
						prir+= (signed char)(Uakk_A[tmp_a]-Uakk_A[tmp_a+1]);
	
			if ( prir <= 0 )
				{	//    10*50/60=8    -  
				if ( ++u_stil_a == 10 ) { if ( !(swt & sw_nimh_nicd) ) flag_err_A|=_akk_err_stil_U;}
				} 
				else   u_stil_a=0;
						
			if (  flag_A & _alg_on  )
				{			
				if ( ! ( flag_A & _fasa1_end ) )
					{
					if ( Uakk_A[0] == Uakk_A[1] ){
						if ( ++large_a == 15 ) { if ( !(swt & sw_nimh_nicd) ) flag_err_A|=_akk_err_stil_U;}// n=40sek 10min= 15
						large_a++;//  
						}
						else
						{
						if ( large_a > maxlarge_a ){
							maxlarge_a=large_a; //   
							countpolk_a=0;
							}
						//-----------------------------
						//-------  -----
						tmp_a=0;
						if ( large_a < maxlarge_a )
							if ( ++countpolk_a > 7 ) tmp_a=1; //   8     2 
						large_a=0;
		
						if ( maxlarge_a <= 2 )
							if ( ++no_polk_a==32 ) tmp_a=1; //       ~32   2 
								
						if ( Uakk_A[0]>570 ) tmp_a=1; //  
						
						if (tmp_a) {
							flag_A|=_fasa1_end;
							maxlarge_a=0;
							countpolk_a=0;
							}
						//-----------------------------
						}
					}
					else	//------------ --------------
					{	//if ( flag_A & _fasa1_end ) 
					if ( prir > maxlarge_a )
						maxlarge_a=prir;
					
					if ( maxlarge_a > prir+1 ) countpolk_a++;
						else countpolk_a=0;
					
					if ( countpolk_a >= 2 ){
			#ifdef versia_alg_2
						if ( prir<=7 )
			#endif
							{
							if ( swt & sw_trickle_on ) 
							state_A=130;
							else
							flag_err_A|=_akk_end_charge;
							}
						}
					}
				}
				send_str(_A_);
			}
			PORTDECH&=~decharge_A;
			PORTLED&=~led_2_A;
			tmp_a=0;
			break;
		
		case (80)://----------------------------------------------------------------
			start_pwm_A( FAST_I,87);//        .
			break;
		case (87):
			delay01_next_state_A(75,70);// /10 //40 old=9
			if (flag_A & _t_r_verify){ //    0,1
				flag_A &= ~_t_r_verify;
				verify_r_a();
				verify_t_a();
				}
			break;	
		case (81)://#########decharge_imp##########
			pwm_A_off();
			PORTDECH|=decharge_A;//  
			PORTLED|=led_2_A;
			state_A=82;					
			break;
		case (82):
			delay01_next_state_A(1,83);// /10 8
			break;
		case (83):
			if ( ++tmp_a==8 ){ 
				state_A=70;
				break;
				}
			state_A=84;	
			PORTDECH&=~decharge_A;
			PORTLED&=~led_2_A;
			break;
		case (84):
			start_pwm_A( FAST_I,85);
			break;
		case (85):
			delay01_next_state_A(9,81);// /10 //40 old=9
			if (flag_A & _t_r_verify){ //    0,1
				flag_A &= ~_t_r_verify;
				verify_r_a();
				verify_t_a();
				}
			break;//#########decharge_imp##########

		//**************[ END FAST CHARGE ]*********************
		
		//--------------   30  ----------------------
		case (130):
			//tmp_a=minute;//min
			usr_a=31;
			PORTLED|=led_2_A;
			set_alarm_time(&clock_A,00,35);
			send_end_err_str(_A_);
			state_A=132;
			break;
		case (132):
			start_pwm_A( trickle_i,134);
			break;
		case (134):
			delay01_next_state_A(2,135);// 10
			PORTLED&=~led_1_A;
			break;
		case(135):
			delay01_next_state_A(2,137);// 10
			PORTLED|=led_1_A;
			break;
		case(137):
			state_A=134;
			verify_r_a();
			verify_t_a();
			if ( trickle_minute_A != minute ){// 1 
				trickle_minute_A=minute;
				if ( --usr_a==0 ) flag_err_A|=_akk_end_charge;
				Uakk_A[0]=stop_pwm_U_rec_A();
				send_str(_A_);
				state_A=132;
				}
			break;
		//--------------   30  ----------------------
		
		//#############  1 ###################
		case (140):
			set_alarm_time(&clock_A,10,00);
			tempir_init_massif_a();
			flag_A=0;
			power_off_ON=0;
			tmp_a=14;
			PORTDECH|=decharge_A;
			PORTLED&=~led_1_A;
			PORTLED|=led_2_A;
			if ( !(btn & btn_decharge_A) ) state_A=141;
			break;
		case (141):
			PORTLED|=led_1_A;
			PORTLED|=led_2_A;
			if ( btn & btn_decharge_A ) state_A=142;
			delay01_next_state_A(20,142);// 10
			break;
		case (142):
			PORTLED&=~led_2_A;
			PORTLED&=~led_1_A;
			if ( btn & btn_decharge_A ){
				state_A=0;
				PORTDECH&=~decharge_A;
				}
			delay01_next_state_A(20,143);// 10
			break;	
		case (143):
			state_A=141;
			Uakk_A[0]=stop_pwm_U_rec_A();
			if ( Uakk_A[0]<=400 ){
				state_A=20;
				PORTDECH&=~decharge_A;
				send_str(_A_);
				}
			
			if ( ++tmp_a==15 ) {
				tmp_a=0;
				send_str(_A_);
				}
			flag_err_A=0;
			break;
			//#############  1 ###################
	}
	//***********************************************************************
		verify_error_A();
		verify_tok_A();
	//***********************************************************************
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	switch (state_B)
	{
		case (0):
			//  
			//if (  swt & sw_uart )
			//seting();
			//else
			//UCSRB=0;
			
			if (!data_error)
				{
				state_B_0();
				start_charge_B();
				}
			break;
		//---------------------error------------------------
		case (1):
			/*if ( swt & sw_uart ) {
				USART_Transmit(0x04);	// 2 
				USART_Transmit(flag_err_B);
				USART_Transmit(0);
				USART_Transmit(0);
				USART_Transmit(0);
				}*/
			send_end_err_str(_B_);
			if ( flag_err_B & _akk_end_charge )
						state_B=0;
				else  	state_B=2;	
			tmp_b=1;
			large_b=flag_err_B;
			flag_err_B=0;
			break;
		case (2):
			PORTLED_2B|=led_2_B;
			delay01_next_state_B(4,3);
			break;
		case (3):
			PORTLED_2B&=~led_2_B;
			//start_charge_B();
			state_B_0();
			delay01_next_state_B(3,4);
			break;
		case (4):
			if	( tmp_b&large_b )
				state_B=5;
				else
				state_B=2;
			tmp_b<<=1;
			break;
		case (5):
			tmp_b=1;
			//start_charge_B();
			state_B_0();
			delay01_next_state_B(12,2);
			break;
		//------------------end--error---------------------
		case (20):
			//if (!state_A)
			data_init();
			UCSRB&=~(BIT(RXCIE)|BIT(RXEN));//  
			PORTDECH&=~decharge_B;
			PORTLED|=led_1_B;
			PORTLED_2B&=~led_2_B;
			
			tmp_b=0, usr_b=0, large_b=0, maxlarge_b=0, countpolk_b=0, u_stil_b=0, no_polk_b=0;
			flag_err_B=0;
			
			power_off_ON=0;
			flag_B=0;
			if ( swt & sw_decharge_imp ) flag_B|=_alg_on;
			
			for(tmp_b=sizeof(Uakk_B)/2-1;tmp_b!=-1;tmp_b--) Uakk_B[tmp_b]=0;
			
			tempir_init_massif_b();
			
			Uakk_B[0]=stop_pwm_U_rec_B();//   .  U>0.8?
			
			set_alarm_time(&clock_B,00,30);
			verify_t_b();//  
			
			/*if ( swt & sw_uart ) {
				USART_Transmit(0x02);	
				USART_Transmit(Uakk_B[0]>>8);
				USART_Transmit(Uakk_B[0]);
				USART_Transmit(last_temper_akk[_B_]>>8);
				USART_Transmit(last_temper_akk[_B_]);
				}*/
			send_str(_B_);
			state_B=25;
			break;
		
		case (25)://************************[    ]*************************
			start_pwm_B( 10, 27 );//  ~ 50ma
			break;
		case (27):
			delay01_next_state_B(50,28);
			if (flag_B & _t_r_verify){
				flag_B &= ~_t_r_verify;
				verify_r_b();//   U > 1,8  .    R - 
				verify_t_b();//  
				}
			break;
		case (28):
			if ( stop_pwm_U_rec_B()>400 ) state_B=50; //     
			else	state_B=25;//     U>1
			break;//**********************[ end    ]**********************	
		
		
		//----------------------------------[    ]-------------------------------	
		case (50)://***********[    ]**************
			set_alarm_time(&clock_B,alarm_time[1],alarm_time[0]);// 
			state_B=51;
			break;
		case (51):
			state_B=52;
			start_pwm_B( FAST_I, 87 );
			break;
		case (52):
			delay01_next_state_B(10,51);//  5sek debug //delay01_next_state_B(50,65);
			if (flag_B & _t_r_verify){
				flag_B &= ~_t_r_verify;
				verify_r_b();//   U > 1,8  .    R - 
				verify_t_b();//  
				}
			break;//***********[    ]**************

		
		case (70)://**************[ FAST CHARGE ]*********************
		//  ,  U   dV0,  ,    40
			if ( swt & sw_decharge_imp )
				state_B=84;
				else{
				state_B=80;
				pwm_A_off();//   
				_delay_ms(30);
				}
				
			Uakk_B[8]+=stop_pwm_U_rec_B();
			if ( ++usr_b >= 8 )
			{
				usr_b=0;
				Uakk_B[8]=Uakk_B[8]/8;//   8 
				
				for ( tmp_b=7 ; tmp_b>0 ; tmp_b-- ){//    
					Uakk_B[tmp_b]=Uakk_B[tmp_b-1];
					}
				Uakk_B[0]=Uakk_B[8];
				Uakk_B[8]=0;
				//    
			//-----------------------------------------------------------------------------------------------
			//----------------- 8  ----------------------------------------------------
			if (  !(flag_B & _alg_on)  )
				if ( ++ large_b == 8 ) {flag_B|=_alg_on; large_b=0;}
			//-----------------------------------------------------------------------------------------------
			
			int8_t prir;
			for ( prir=tmp_b=0; tmp_b<7 ; tmp_b++ )//  
						prir+= (signed char)(Uakk_B[tmp_b]-Uakk_B[tmp_b+1]);
	
			if ( prir <= 0 )
				{	//    12*40/60=8    -  
				if ( ++u_stil_b == 10 ) { if ( !(swt & sw_nimh_nicd) ) flag_err_B|=_akk_err_stil_U;}
				} 
				else   u_stil_b=0;
						
			if (  flag_B & _alg_on  )
				{
				if ( ! ( flag_B & _fasa1_end ) )
					{
					if ( Uakk_B[0] == Uakk_B[1] ){
						if ( ++large_b == 15 ) { if ( !(swt & sw_nimh_nicd) ) flag_err_B|=_akk_err_stil_U;}// n=40sek 10min= 15
						large_b++;//  
						}
						else
						{
						if ( large_b > maxlarge_b ){
							maxlarge_b=large_b; //   
							countpolk_b=0;
							}
						//-----------------------------
						//-------  -----
						tmp_b=0;
						if ( large_b < maxlarge_b )
							if ( ++countpolk_b > 7 ) tmp_b=1; //   8     2 
						large_b=0;
		
						if ( maxlarge_b <= 2 )
							if ( ++no_polk_b==32 ) tmp_b=1; //       ~32   2 
								
						if ( Uakk_B[0]>570 ) tmp_b=1; //  
						
						if (tmp_b) {
							flag_B|=_fasa1_end;
							maxlarge_b=0;
							countpolk_b=0;
							}
						//-----------------------------
						}
					}
					else	//------------ --------------
					{	//if ( flag_B & _fasa1_end ) 
					//for ( large_b=tmp_b=0; tmp_b<7 ; tmp_b++ )
					//	large_b+= (signed char)(Uakk_B[tmp_b]-Uakk_B[tmp_b+1]);
					
					if ( prir > maxlarge_b )
						maxlarge_b=prir;
					
					if ( maxlarge_b > prir+1 ) countpolk_b++;
						else countpolk_b=0;
					
					if ( countpolk_b >= 2 ){
			#ifdef versia_alg_2
						if ( prir<=7 )
			#endif
							{
							if ( swt & sw_trickle_on ) 
							state_B=130;
							else
							flag_err_B|=_akk_end_charge;
							}
						}
					}
				}
				send_str(_B_);
			}
			PORTDECH&=~decharge_B;
			PORTLED_2B&=~led_2_B;
			tmp_b=0;	
			break;
		
		case (80)://----------------------------------------------------------------
			start_pwm_B( FAST_I,87);//        .
			break;
		case (87):
			delay01_next_state_B(75,70);// /10 //40 old=9
			if (flag_B & _t_r_verify){ //    0,1
				flag_B &= ~_t_r_verify;
				verify_r_b();
				verify_t_b();
				}
			break;	
		case (81)://#########decharge_imp##########
			pwm_B_off();
			PORTDECH|=decharge_B;//  
			PORTLED_2B|=led_2_B;
			state_B=82;					
			break;
		case (82):
			delay01_next_state_B(1,83);
			break;
		case (83):
			if ( ++tmp_b==8 ){ 
				state_B=70;
				break;
				}
			state_B=84;	
			PORTDECH&=~decharge_B;
			PORTLED_2B&=~led_2_B;
			break;
		case (84):
			start_pwm_B( FAST_I,85);
			break;
		case (85):
			delay01_next_state_B(9,81);// /10 //40 old=9
			if (flag_B & _t_r_verify){ //    0,1
				flag_B &= ~_t_r_verify;
				verify_r_b();
				verify_t_b();
				}
			break;//#########decharge_imp##########
		//**************[ END FAST CHARGE ]*********************
		
		//--------------   30  ----------------------
		case (130):
			usr_b=31;
			PORTLED_2B|=led_2_B;
			set_alarm_time(&clock_B,00,35);
			send_end_err_str(_B_);
			state_B=132;
			break;
		case (132):
			start_pwm_B( trickle_i,134);
			break;
		case (134):
			delay01_next_state_B(2,135);// 10
			PORTLED&=~led_1_B;
			break;
		case(135):
			delay01_next_state_B(2,137);// 10
			PORTLED|=led_1_B;
			break;
		case(137):
			state_B=134;
			verify_r_b();
			verify_t_b();
			if ( trickle_minute_B != minute ){// 1 
				trickle_minute_B=minute;
				if ( --usr_b==0 ) flag_err_B|=_akk_end_charge;
				Uakk_B[0]=stop_pwm_U_rec_B();
				send_str(_B_);
				state_B=132;
				}
			break;
		//--------------   30  ----------------------
		
		//#############  1 ###################
		case (140):
			set_alarm_time(&clock_B,10,00);
			tempir_init_massif_b();//           
			flag_B=0;
			power_off_ON=0;
			tmp_b=14;
			PORTDECH|=decharge_B;
			PORTLED&=~led_1_B;
			PORTLED_2B|=led_2_B;
			if ( !(btn & btn_decharge_B) ) state_B=141;
			break;
		case (141):
			PORTLED|=led_1_B;
			PORTLED_2B|=led_2_B;
			if ( btn & btn_decharge_B ) state_B=142;
			delay01_next_state_B(20,142);// 10
			break;
		case (142):
			PORTLED_2B&=~led_2_B;
			PORTLED&=~led_1_B;
			if ( btn & btn_decharge_B ){
				state_B=0;
				PORTDECH&=~decharge_B;
				}
			delay01_next_state_B(20,143);// 10
			break;	
		case (143):
			state_B=141;
			Uakk_B[0]=stop_pwm_U_rec_B();
			if ( Uakk_B[0]<=400 ){
				state_B=20;
				PORTDECH&=~decharge_B;
				send_str(_B_);
				}
			
			if ( ++tmp_b==15 ) {
				tmp_b=0;
				send_str(_B_);
				}
			flag_err_B=0;
			break;
			//#############  1 ###################
	}
	//***********************************************************************
		verify_error_B();
		verify_tok_B();
	//***********************************************************************

}

}
















